var targetItem        = 'gms';
var isPlaying         = false;
var animationInterval = 500;
var py_command        = null;
var retrievingItem    = null;
var animationController = null;
var logging = true;
var expanded = true;
var panelRange = { left:45, top:50, right:274, bottom:224 };

function debug( message ) {
    if ( !logging ) return;
    if ( window.Logger ) {
        Logger.log( '' + message );
    }
    //document.getElementById( 'debugDiv' ).innerText = message;
}

function setLargeLayout() {
    if ( expanded ) return;

    setBackgroundImage( "front", "Images/large_Default.png" );
    setBackgroundImage( "frame", "Images/FrontFrame.png" );
    setBackgroundImage( "behind", "Images/BackFrame.png" );

    setBackgroundImage( "playButton", "Images/ButtonBG2.png" );
    setBackgroundImage( "gmsButton", "Images/ButtonBG.png" );
    setBackgroundImage( "chartButton", "Images/ButtonBG.png" );
    setBackgroundImage( "tempButton", "Images/ButtonBG.png" );
    setBackgroundImage( "rainButton", "Images/ButtonBG.png" );

    translateElement( "graph", 44, 44, 320, 240 );

    translateElement( "playButton", 40, 280, 40, 40 );
    translateElement( "gmsButton", 100, 280, 75, 40 );
    translateElement( "chartButton", 160, 280, 75, 40 );
    translateElement( "rainButton", 220, 280, 75, 40 );
    translateElement( "tempButton", 280, 280, 75, 40 );
    translateElement( "flip", 352, 295, 13, 13 );
    translateElement( "flipIcon", 352, 295, 13, 13 );
    
    if ( window.widget ) {
        widget.setCloseBoxOffset( 32, 28 );
    }

    panelRange = { left:45, top:50, right:274, bottom:224 };
    var elem = document.getElementById( "messagePanel" );

    if ( elem ) {
        panelPosition.x = 50;
        panelPosition.y = 220;
        elem.style.left = panelPosition.x + "px";
        elem.style.top = panelPosition.y + "px";
    }

    expanded = true;
}

function setSmallLayout() {
    if ( expanded == false ) return;

    translateElement( "graph", 88, 86, 228, 171 );
    //translateElement( "frame", 0, 0, 100, 100 );

    setBackgroundImage( "front", "Images/small_Default.png" );
    setBackgroundImage( "frame", "Images/small_FrontFrame.png" );
    setBackgroundImage( "behind", "Images/small_BackFrame.png" );

    setBackgroundImage( "playButton", "Images/small_ButtonBG2.png" );
    setBackgroundImage( "gmsButton", "Images/small_ButtonBG.png" );
    setBackgroundImage( "chartButton", "Images/small_ButtonBG.png" );
    setBackgroundImage( "tempButton", "Images/small_ButtonBG.png" );
    setBackgroundImage( "rainButton", "Images/small_ButtonBG.png" );

    translateElement( "playButton", 86, 252, 28, 28 );
    translateElement( "gmsButton", 129, 252, 53, 28 );
    translateElement( "chartButton", 171, 252, 53, 28 );
    translateElement( "rainButton", 213, 252, 53, 28 );
    translateElement( "tempButton", 255, 252, 53, 28 );
    translateElement( "flip", 307, 260, 13, 13 );
    translateElement( "flipIcon", 307, 260, 13, 13 );

    if ( window.widget ) {
        widget.setCloseBoxOffset( 81, 78 );
    }

//     document.getElementById( "frame" ).style.zIndex = 150;
//     document.getElementById( "graph" ).style.zIndex = 110;

    // reset panel moving range
    panelRange = { left:88, top:86, right:232, bottom:189 };
    if ( panelPosition.x < panelRange.left ) {
        panelPosition.x = panelRange.left;
    }
    if ( panelPosition.x > panelRange.right ) {
        panelPosition.x = panelRange.right;
    }
    if ( panelPosition.y < panelRange.top ) {
        panelPosition.y = panelRange.top;
    }
    if ( panelPosition.y > panelRange.bottom ) {
        panelPosition.y = panelRange.bottom;
    }

    var elem = document.getElementById( "messagePanel" );

    if ( elem ) {
        elem.style.left = panelPosition.x + "px";
        elem.style.top = panelPosition.y + "px";
    }

    expanded = false;
}


function translateElement( id, x, y, width, height ) {
    var elem = document.getElementById( id );
    debug( id + " => ( " + x + ", " + y + ", " + width + ", " + height + " )" );
    if ( elem ) {
        elem.style.width  = width + "px";
        elem.style.height = height + "px";
        elem.style.left   = x + "px";
        elem.style.top    = y + "px";

    } else {
        debug( "no element named " + id );
    }
}


function setBackgroundImage( id, url ) {
    var elem = document.getElementById( id );
    debug( id + " => " + url );
    if ( elem ) {
        elem.style.background = "url(" + url + ")";
    } else {
        debug( "no element " + id );
    }
}

function expand() {
    var windowWidth = 400;
    var windowHeight = 350;
    var ratio = 1.0 / 0.71;
    var ids = [ "widget", "frame", "graph", "gmsButton", "chartButton", "rainButton", "tempButton", "playButton" ]; 
    for ( var i = 0; i < ids.length; i++ ) {
        resizeElement( ids[ i ], windowWidth, windowHeight, ratio, false );
    }
    ids = [ "flip", "flipIcon" ];
    for ( var i = 0; i < ids.length; i++ ) {
        resizeElement( ids[ i ], windowWidth, windowHeight, ratio, true );
    }

    setBackgroundImage( "widget", "Default.png" );
    setBackgroundImage( "frame", "Images/Frame.png" );

    setBackgroundImage( "playButton", "Images/ButtonBG2.png" );
    setBackgroundImage( "gmsButton", "Images/ButtonBG.png" );
    setBackgroundImage( "chartButton", "Images/ButtonBG.png" );
    setBackgroundImage( "tempButton", "Images/ButtonBG.png" );
    setBackgroundImage( "rainButton", "Images/ButtonBG.png" );
}


// initialization
function init() {
    debug( 'init' );
    var img = document.getElementById( 'graph' );
    if ( img == null ) {
        debug( 'no graph' );
        return;
    }

    if ( window.widget ) {
        widget.onremove = cleanUp;

        if ( widget.preferenceForKey( 'AnimationInterval' ) ) {
            //debug( widget.preferenceForKey( 'AnimationInterval' ) );
            animationInterval = parseInt( widget.preferenceForKey( 'AnimationInterval' ) );
        }

        // panel
        if ( widget.preferenceForKey( 'panelX' ) && widget.preferenceForKey( 'panelY' ) ) {
            var elem = document.getElementById( 'messagePanel' );
            var px = parseInt( widget.preferenceForKey( 'panelX' ) );
            var py = parseInt( widget.preferenceForKey( 'panelY' ) );
            elem.style.left = px + "px";
            elem.style.top  = py + "px";
            panelPosition = { x:px, y:py };
        }

        // interval
        var elem = document.getElementById( 'animationSpeed' );
        var children = elem.childNodes;
        for ( var i = 0; i < children.length; i++ ) {
            if ( children[ i ].value && parseInt( children[ i ].value ) == animationInterval ) {
                children[ i ].setAttribute( 'selected' );
                break;
            }
        }
        setTimeout( loadInitialImage, 0 );
        invokeBackgroundLoaders();

        // resize?
        var flag_size = widget.preferenceForKey( "LargeWindow" );
        if ( flag_size == null || flag_size == undefined ) {
            flag_size = "true";
        }
        if ( flag_size != "true" ) {
            setSmallLayout();
            expanded = false;
        } else {
            expanded = true;
        }

    }


    // done button
    createGenericButton( document.getElementById( 'done' ), tr( "Done" ), flipToFront );

}

function cleanUp() {
    var style = document.defaultView.getComputedStyle( document.getElementById( 'messagePanel' ) );
    var px = parseInt( style.getPropertyValue( 'left' ) );
    var py = parseInt( style.getPropertyValue( 'top' ) );
    widget.setPreferenceForKey( px, 'panelX' );
    widget.setPreferenceForKey( py, 'panelY' );
}

function setAnimationInterval( interval ) {
    if ( interval > 10 ) {
        animationInterval = interval;
    }
}

function resolveURIs( output ) {
    var URIs = new Array();
    if ( output && output.length > 0 ) {
        var lines = output.split( '\n' );
        var base_uri = lines[ 0 ];
        for ( var i = output.length - 1; i >= 1; i-- ) {
            if ( lines[ i ] && lines[ i ].length > 0 ) {
                var uri = base_uri + lines[ i ] + '.jpg';
                debug( uri );
                URIs.push( uri );
            }
        }
    }
    return URIs;
}

function loadInitialImage() {
    availableImages = "";
    var listCommand = widget.system( "/usr/bin/python getchart.py gms -list", null );
    var output = listCommand.outputString;
    var error = listCommand.errorString;
    if ( error && error.length > 0 ) {
        //showErrorMessage( error );
        debug( error );
    }
    if ( output && output.length > 0 ) {
        var lines = output.split( '\n' );
        if ( lines.length > 1 ) {
            var base_uri = lines[ 0 ];
            var uri = base_uri + lines[ 1 ] + '.jpg';
            showGraph( targetItem, uri );
        }
    } else {
        debug( 'no images' );
    }
    listCommand = null;
    loadGraph( targetItem );
    document.getElementById( 'playButton' ).src = "Images/ButtonPlay1.png";
}

// transit to preference
function flipToBehind(event) {
    var front  = document.getElementById( "front" ); 
    var behind = document.getElementById( "behind" ); 
    widget.prepareForTransition("ToBack"); 
    behind.style.display  = "block"; 
    front.style.display = "none"; 
    
    if (window.widget) {
        setTimeout ('widget.performTransition();', 10 );  
    }
}

// transit to main face
function flipToFront(event){
    var front  = document.getElementById( "front" ); 
    var behind = document.getElementById( "behind" ); 
    widget.prepareForTransition("ToFront"); 

    animationInterval = parseInt( document.getElementById( "animationSpeed" ).value );
    behind.style.display  = "none"; 
    front.style.display = "block"; 

    var wsize = document.getElementById( "windowSize" ).value;
    debug( wsize );
    if ( wsize == "large" ) {
        setLargeLayout();
        widget.setPreferenceForKey( "true", "LargeWindow" );
    } else {
        setSmallLayout();
        widget.setPreferenceForKey( "false", "LargeWindow" );
    }
    
    if (window.widget) {
        widget.setPreferenceForKey( animationInterval, 'AnimationInterval' );
        setTimeout ('widget.performTransition();', 10 );  
    }
    
}

// translation for the future 
function tr( key ) {
    return key;
}

// background loading
function invokeBackgroundLoaders() {
    var int_reload = 60000 * 20; // retrieve new data after every 20min
    var wait_chart = 300000;     // interval of each ping

    setTimeout( function() { loadChartWithInterval( 'gms', int_reload ); }, wait_chart );
    setTimeout( function() { loadChartWithInterval( 'chart', int_reload * 4 ); }, wait_chart * 2 );
    setTimeout( function() { loadChartWithInterval( 'rain', int_reload ); }, wait_chart * 3 );
    setTimeout( function() { loadChartWithInterval( 'temp', int_reload ); }, wait_chart * 4 );

}


function loadChartWithInterval( item, duration ) {
    debug( "set interval " + item  + " " + duration + " in loadChartWithInterval" );
    setInterval( function(){ loadGraph( item ); }, duration );
}

// load graph if no external script are running
function loadGraph( item ) {
    if ( py_command != null ) {
        debug( 'already retrieving ' + retrievingItem + ", then loading '" + item + "' must wait for completion" );
        return;
    }
    
    var command = "/usr/bin/python getchart.py " + item;
    if ( item == targetItem ) {
        document.getElementById( 'graph' ).style.opacity = '0.5';
        document.getElementById( 'messageText' ).innerHTML = "Loading";
    }
    debug( 'Python : ' + command );
    retrievingItem = item.substring( 0, item.length );
    py_command = widget.system( command, newGraphHandler );
}

// cancel current process and load
function forceLoadGraph( item ) {
    if ( py_command != null ) {
        if ( item == retrievingItem ) return;
        py_command.cancel();
    }
    loadGraph( item );
}

// process new graph
function newGraphHandler() {
    if ( py_command == null ) {
        debug( 'no command' );
        return;
    }
    var output = py_command.outputString;
    var error  = py_command.errorString;
    if ( error && error != undefined && error.length > 0 ) {
        debug( error );
        //showErrorMessage( error );
    }
    if ( output ) {
        debug( 'new graph : ' + output );
        var outputs = output.split( "\n" );
        var uri = outputs[ 0 ];
        if ( retrievingItem == targetItem ) {
            showGraph( targetItem, uri );
        } else {
            debug( "store '" + uri + "' to backyard : " + targetItem + '/' + retrievingItem );
        }
    } 
    py_command = null;
    retrievingItem = null;
}


function resolveItemName( item ) {
    if ( item == 'gms' ) {
        return "衛星写真";
    } else if ( item == 'chart' ) {
        return "天気図";
    } else if ( item == 'rain' ) {
        return "降水量";
    } else if ( item == 'temp' ) {
        return "気温";
    } else {
        return "??";
    }
}

function getDateFromURI( uri ) {
    var ps = uri.lastIndexOf( '/' );
    var pp = uri.lastIndexOf( '.' );
    var year = "1900";
    var month = "00";
    var day = "00";
    var hour = "00";
    if ( ps == -1 ) ps = 0;
    if ( pp == -1 ) pp = uri.length;
    if ( pp - ps >= 11 ) {
        year = uri.substring( ps + 1, ps + 5 );
        month = uri.substring( ps + 5, ps + 7 );
        day = uri.substring( ps + 7, ps + 9 );
        hour = uri.substring( ps + 9, ps + 11 );
    }
    return [ year, month, day, hour ];
}

function changeGraph( item ) {
    if ( isPlaying ) {
        debug( 'cannot change while animation' );
        return;
    }
    debug( "chageGraph " + item );
    targetItem = item;
    forceLoadGraph( item );
    return;
}

function showErrorMessage( message ) {
    if ( message == null || message == undefined ) {
        message = "エラー発生";
    }
    document.getElementById( 'graph' ).src = "Images/Empty.png";
    document.getElementById( 'messageText' ).innerText = message;
}

function showGraph( item, uri ) {
    debug( 'showGraph ' + item + " " + uri );
    var tempURI = uri + "?" + (new Date()).getTime();
    var itemName = resolveItemName( item );
    var date = getDateFromURI( uri );
    var graph = document.getElementById( 'graph' );
    
    graph.src = tempURI;
    graph.style.opacity = '1.0';

    if ( uri.indexOf( "http:" ) >= 0 ) {
        var d = new Date();
        document.getElementById( 'messageText' ).innerHTML = itemName + "<br/>" + ( d.getMonth() + 1 ) + "/" + d.getDate() + "/" + d.getHours();
    } else {
        document.getElementById( 'messageText' ).innerHTML = itemName + "<br/>" + date[ 1 ] + "/" + date[ 2 ] + "/" + date[ 3 ];
    }
}




///////////// animation
function playMouseDown( event ) {
    if ( isPlaying ) {
        debug( "STOPPPING" );
        document.getElementById( 'playButton' ).src="Images/ButtonStop2.png";
        window.addEventListener( "mouseup", stopMouseUp, true );
        window.addEventListener( "mouseexit", revertStopButton, true );
        return;
    } else {
        document.getElementById( 'playButton' ).src="Images/ButtonPlay2.png";
        window.addEventListener( "mouseup", playMouseUp, true );
        window.addEventListener( "mouseexit", revertPlayButton, true );
    }
}

function revertPlayButton( event ) {
    document.getElementById( 'playButton' ).src="Images/ButtonPlay1.png";
    window.removeEventListener( "mouseup", playMouseUp, true );
    window.removeEventListener( "mouseexit", revertPlayButton, true );
//     event.stopPropagation(); 
//     event.preventDefault(); 
}

function revertStopButton( event ) {
    document.getElementById( 'playButton' ).src="Images/ButtonStop1.png";
    window.removeEventListener( "mouseup", stopMouseUp, true );
    window.removeEventListener( "mouseexit", revertStopButton, true );
//     event.stopPropagation(); 
//     event.preventDefault(); 
}


function AnimationFrame( item, uris ) {
    this.item  = item;
    this.uris  = uris;
    this.count = 0;
    this.tick  = AnimationFrame__tick;
    this.stop  = AnimationFrame__stop;
    this.timer = null;
}

function AnimationFrame__tick() {
    debug( 'ANIMATION START ' + this.count + " " + this.uris.length + " " + this.uris[ this.count ] );
    showGraph( this.item, this.uris[ this.count ] );
    this.count ++;
    if ( this.count >= this.uris.length ) {
        if ( this.timer ) {
            //debug( 'stop' );
            clearInterval( this.timer );
            this.timer = null;
            isPlaying = false;
            animationController = null;
            document.getElementById( 'playButton' ).src = "Images/ButtonPlay1.png";
        } else {
            debug( "continueing " + this.count );
        }
    }
}

function AnimationFrame__stop() {
    if ( this.timer ) {
        clearInterval( this.timer );
        this.timer = null;
        isPlaying = false;
        animationController = null;
        document.getElementById( 'playButton' ).src="Images/ButtonPlay1.png";
    }
}

// initiate animation
function invokeAnimation() {
    var command = "/usr/bin/python getchart.py " + targetItem + " -list";
    var pycom = widget.system( command, null );
    var output = pycom.outputString;
    var error = pycom.errorString;
    var URIs = resolveURIs( output );

    if ( error ) {
        debug( error );
        showMessage( error );
        return;
    }
    document.getElementById( 'playButton' ).src="Images/ButtonStop1.png";
    animationController = new AnimationFrame( targetItem, URIs );
    isPlaying = true;
    animationController.timer 
        = setInterval( function(){ animationController.tick(); }, animationInterval );
    
}


// stop animation
function stopAnimation() {
    debug( 'stop animation' );
    if ( animationController != null && isPlaying == true ) {
        animationController.stop();
    } else {
        debug( "NOT STOPPED " + isPlaying );
    }
}



//////////// key events

function _mouse_down( event, upHandler, bname, img ) {
    window.addEventListener( 'mouseup', upHandler, true );
    document.getElementById( bname ).src = img;
//     event.stopPropagation(); 
//     event.preventDefault(); 
}

function _mouse_up( event, upHandler, bname, img ) {
    window.removeEventListener( 'mouseup', upHandler, true );
    document.getElementById( bname ).src = img;
//     event.stopPropagation(); 
//     event.preventDefault(); 
}

// receive play button action
function playMouseUp( event ) {
    revertPlayButton( event );
    debug( 'start animation' );
    
    if ( window.widget ) {
        invokeAnimation();
    }
}

// receive stop button action
function stopMouseUp( event ) {
    debug( "STOPPING ....." );
    revertStopButton( event );
    stopAnimation();
}

function gmsMouseDown( event ) {
    if ( isPlaying ) return;
    _mouse_down( event, gmsMouseUp, "gmsButton", "Images/ButtonGMS2.png" );
}

function gmsMouseUp( event ) {
    _mouse_up( event, gmsMouseUp, "gmsButton", "Images/ButtonGMS1.png" );
    changeGraph( 'gms' );
}


function chartMouseDown( event ) {
    if ( isPlaying ) return;
    _mouse_down( event, chartMouseUp, "chartButton", "Images/ButtonChart2.png" );
}

function chartMouseUp( event ) {
    _mouse_up( event, chartMouseUp, "chartButton", "Images/ButtonChart1.png" );
    changeGraph( 'chart' );
}

function rainMouseDown( event ) {
    if ( isPlaying ) return;
    _mouse_down( event, rainMouseUp, "rainButton", "Images/ButtonRain2.png" );
}

function rainMouseUp( event ) {
    _mouse_up( event, rainMouseUp, "rainButton", "Images/ButtonRain1.png" );
    changeGraph( 'rain' );
}

function tempMouseDown( event ) {
    if ( isPlaying ) return;
    _mouse_down( event, tempMouseUp, "tempButton", "Images/ButtonTemp2.png" );
}

function tempMouseUp( event ) {
    _mouse_up( event, tempMouseUp, "tempButton", "Images/ButtonTemp1.png" );
    changeGraph( 'temp' );
}


var lastPos = { x:0, y:0 };
var panelPosition = { x:0, y:0 };
var panelDraggingFlag = false;

function panelDragStart(event) {
    var style = document.defaultView.getComputedStyle( document.getElementById( 'messagePanel' ) );
    var px = parseInt( style.getPropertyValue( 'left' ) );
    var py = parseInt( style.getPropertyValue( 'top' ) );

    lastPos = { x:event.x, y:event.y };
    panelPosition = { x:px, y:py };

    window.addEventListener( 'mousemove', panelDragging, true );
    window.addEventListener( 'mouseup', panelDragEnd, true );
}

function panelDragging( evnet ) {
    var dx = event.x - lastPos.x;
    var dy = event.y - lastPos.y;
    var elem = document.getElementById( "messagePanel" );
    panelPosition.x += dx;
    panelPosition.y += dy;
    if ( panelPosition.x < panelRange.left ) {//45 ) {
        panelPosition.x = panelRange.left;//45;
    }
    if ( panelPosition.x > panelRange.right ) {//274 ) {
        panelPosition.x = panelRange.right;//274;
    }
    if ( panelPosition.y < panelRange.top ) {//50 ) {
        panelPosition.y = panelRange.top;//50;
    }
    if ( panelPosition.y > panelRange.bottom ) {//224 ) {
        panelPosition.y = panelRange.bottom;//224;
    }
    elem.style.left = panelPosition.x + "px";
    elem.style.top  = panelPosition.y + "px";
    lastPos.x = event.x;
    lastPos.y = event.y;
}

function panelDragEnd(event) {
    window.removeEventListener( 'mousemove', panelDragging, true );
    window.removeEventListener( 'mouseup', panelDragEnd, true );
}
